Gentoo Forums
Gentoo Forums
Gentoo Forums
Quick Search: in
Gentoo 64 Bit für Raspberry bauen
View unanswered posts
View posts from last 24 hours
View posts from last 7 days

 
Reply to topic    Gentoo Forums Forum Index Deutsches Forum (German)
View previous topic :: View next topic  
Author Message
alexander_ro
Tux's lil' helper
Tux's lil' helper


Joined: 22 Nov 2014
Posts: 112

PostPosted: Thu Oct 12, 2017 8:59 am    Post subject: Gentoo 64 Bit für Raspberry bauen Reply with quote

Hey Mädels ... Jungs ... :)

Ich versuche gerade nach dieser Beschreibung: https://wiki.gentoo.org/wiki/Raspberry_Pi_3_64_bit_Install#Fetch_the_Gentoo_bits_of_the_install ein Gentoo 64 Bit für einen Raspberry Pi 3 zu bauen. Leider läuft bei mir schon das erstellen der ARM Toolchain mit "crossdev -t aarch64-unknown-linux-gnu" nicht.

Im Logfile beschwert der sich darüber das ich die Stabile Verson 2.28.1 der binutils für den Host amd64 benutze. Das irritiert mich jetzt doch ein wenig weil ich ja die nicht für amd64 sondern arm64 bauen will.
Code:

Calculating dependencies  ..... done!
[ebuild     U ~] sys-libs/binutils-libs-2.29.1 [2.28.1]
[ebuild  N    ~] cross-aarch64-unknown-linux-gnu/binutils-2.29.1  USE="cxx nls -multitarget -static-libs {-test} -vanilla"

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

sys-libs/binutils-libs:0

  (sys-libs/binutils-libs-2.29.1:0/2.29.1::gentoo, ebuild scheduled for merge) pulled in by
    >=sys-libs/binutils-libs-2.29.1 required by (cross-aarch64-unknown-linux-gnu/binutils-2.29.1:2.29.1/2.29.1::local-crossdev, ebuild scheduled for merge)
    ^^                       ^^^^^^

  (sys-libs/binutils-libs-2.28.1:0/2.28.1::gentoo, installed) pulled in by
    sys-libs/binutils-libs:0/2.28.1=[abi_x86_64(-)] required by (x11-libs/cairo-1.14.8:0/0::gentoo, installed)
                          ^^^^^^^^^^


Hat da vielleicht jemand eine Erklärung dafür warum das mit der 2.28.1 der binutlis nicht gehen soll?

Grüße
Alexander
Back to top
View user's profile Send private message
bbgermany
Veteran
Veteran


Joined: 21 Feb 2005
Posts: 1697
Location: Oranienburg/Germany

PostPosted: Thu Oct 12, 2017 9:15 am    Post subject: Reply with quote

Hi,

versuche einfach die Stable Crossdev Chain zu erstellen:

Code:

crossdev -t aarch64-unknown-linux-gnu -S


Dann sollte das auch funktionieren.

MfG. Stefan
_________________
1st: i5-4440, 16GB, 1.75TB
2nd: i5-3470T, 8GB, 620GB
3rd: i5-3450, 12GB, 64GB USB+ 6.25TB
4th: Asus N61VN, 8GB, 120GB
5th: RPi, 512MB, 8GB USB + NFS
6th: C2D T7200, 2GB, 16GB USB + NFS
7th: RPi3 1GB, 64GB USB
Back to top
View user's profile Send private message
alexander_ro
Tux's lil' helper
Tux's lil' helper


Joined: 22 Nov 2014
Posts: 112

PostPosted: Thu Oct 12, 2017 6:00 pm    Post subject: Reply with quote

Stimmt das funktioniert ... :)
Mir reicht das so nur so aus Interesse: man müsste doch normal auch die neuere Version für die Crosstools nehmen können auch wenn der Host noch die ältere Version verwendet. Oder habe ich da was falsch verstanden?

Mit "emerge --search rasp" findet man folgende Pakete:
Code:

*  media-libs/raspberrypi-userland [ Masked ]
      Latest version available: 9999
      Latest version installed: [ Not Installed ]
      Size of files: 0 KiB
      Homepage:      https://github.com/raspberrypi/userland
      Description:   Raspberry Pi userspace tools and libraries
      License:       BSD

*  media-libs/raspberrypi-userland-bin [ Masked ]
      Latest version available: 1.20170303
      Latest version installed: [ Not Installed ]
      Size of files: 116.103 KiB
      Homepage:      https://github.com/raspberrypi/firmware
      Description:   Raspberry Pi userspace tools and libraries
      License:       BSD GPL-2 raspberrypi-videocore-bin

*  media-video/raspberrypi-omxplayer [ Masked ]
      Latest version available: 9999
      Latest version installed: [ Not Installed ]
      Size of files: 0 KiB
      Homepage:      https://github.com/popcornmix/omxplayer
      Description:   Command line media player for the Raspberry Pi
      License:       GPL-2

*  sys-boot/raspberrypi-firmware [ Masked ]
      Latest version available: 9999
      Latest version installed: [ Not Installed ]
      Size of files: 0 KiB
      Homepage:      https://github.com/raspberrypi/firmware
      Description:   Raspberry PI boot loader and firmware
      License:       GPL-2 raspberrypi-videocore-bin

*  sys-boot/raspberrypi-mkimage [ Masked ]
      Latest version available: 0_p20120201
      Latest version installed: [ Not Installed ]
      Size of files: 0 KiB
      Homepage:      https://github.com/raspberrypi/tools/
      Description:   Raspberry Pi kernel mangling tool mkimage/imagetool-uncompressed.py
      License:       GPL-2

*  sys-kernel/raspberrypi-image [ Masked ]
      Latest version available: 4.1.19_p20160309
      Latest version installed: [ Not Installed ]
      Size of files: 112.963 KiB
      Homepage:      https://github.com/raspberrypi/firmware
      Description:   Raspberry PI boot loader and firmware
      License:       GPL-2 raspberrypi-videocore-bin

*  sys-kernel/raspberrypi-sources [ Masked ]
      Latest version available: 4.14.9999
      Latest version installed: [ Not Installed ]
      Size of files: 0 KiB
      Homepage:      https://github.com/raspberrypi/linux
      Description:   Raspberry PI kernel sources
      License:       GPL-2 freedist

Ist es sinnvoll diese Pakete zu benützen statt dem im Wiki angegebenen Weg die selbst herunter zu laden?
Back to top
View user's profile Send private message
bbgermany
Veteran
Veteran


Joined: 21 Feb 2005
Posts: 1697
Location: Oranienburg/Germany

PostPosted: Fri Oct 13, 2017 6:00 am    Post subject: Reply with quote

Hi,

du kannst schon eine andere Version der Werkzeuge installieren, dann bist du jedoch daran gebunden eine komplette lokale crossdev Umgebung aufzubauen. Distcc kannst du dann vergessen, da auch hier die Compiler die gleiche Version benötigen.

Außerdem habe ich festgestellt, dass sich einige Pakete nicht übersetzen lassen, wenn du diese in deiner lokalen crossdev Umgebung versuchst zu installieren. Ich nutze deswegen für meine diversen ARM Systeme (RPi B, RPi 3B und Cubietruck) nur Distcc auf diversen x86/x86_64 Systemen und nur die Stable Toolchain!!!

MfG. Stefan
_________________
1st: i5-4440, 16GB, 1.75TB
2nd: i5-3470T, 8GB, 620GB
3rd: i5-3450, 12GB, 64GB USB+ 6.25TB
4th: Asus N61VN, 8GB, 120GB
5th: RPi, 512MB, 8GB USB + NFS
6th: C2D T7200, 2GB, 16GB USB + NFS
7th: RPi3 1GB, 64GB USB
Back to top
View user's profile Send private message
alexander_ro
Tux's lil' helper
Tux's lil' helper


Joined: 22 Nov 2014
Posts: 112

PostPosted: Fri Oct 13, 2017 9:58 am    Post subject: Reply with quote

Hi,

danke für die Info. Ich probiere das mit dem Crosscompilieren zum ersten mal. Bisher habe ich immer den binären Orginal Kernel vom Raspian benutzt und damit das Stage3 von Gentoo gebootet. Sobald das lief habe ich dann den Raspi zum Compilieren benutzt. Bei Kernel oder großen Paketen dauert das aber schon mal über Nacht bis der damit fertig wird. Wenn man mit Kernel Einstellungen spielen will ist das ein klein wenig Lästig ... ;)

Bisher waren das aber auch immer nur 32 Bit Versionen. Aber wenn die CPU schon 64 Bit kann will ich das zumindest mal ausprobieren.

Grüße
Alexander
Back to top
View user's profile Send private message
bbgermany
Veteran
Veteran


Joined: 21 Feb 2005
Posts: 1697
Location: Oranienburg/Germany

PostPosted: Fri Oct 13, 2017 4:15 pm    Post subject: Reply with quote

Hi,

auf meinen PIs verwende ich auch nur den vorkompilierten Kernel von hexxeh (rpi-update). Wenn du distcc verwendest mit crosscompile kannst du bei vielen Paketen die Zeit zum übersetzen reduzieren. GCC jedoch ist zum Beispiel ein Paket, wo das jedoch leider nicht geht :(

BTW, auch der Kernel lässt sich via distcc übersetzen. Mache ich hier regelmäßig für meine x86_64 Systeme.

MfG. Stefan
_________________
1st: i5-4440, 16GB, 1.75TB
2nd: i5-3470T, 8GB, 620GB
3rd: i5-3450, 12GB, 64GB USB+ 6.25TB
4th: Asus N61VN, 8GB, 120GB
5th: RPi, 512MB, 8GB USB + NFS
6th: C2D T7200, 2GB, 16GB USB + NFS
7th: RPi3 1GB, 64GB USB
Back to top
View user's profile Send private message
alexander_ro
Tux's lil' helper
Tux's lil' helper


Joined: 22 Nov 2014
Posts: 112

PostPosted: Sun Oct 15, 2017 8:07 am    Post subject: Reply with quote

Hi,

den distcc habe ich bisher auch nicht benützt. Wenn man mehrere Pis hat müsste das dann auch schneller werden wenn das Compilieren auf mehrere verteilt wird. Die Intel Rechner von mir sind eigentlich schnell genug das es ein einzelner Rechner schafft. Mein Notebook mit SSD braucht nur zwei oder drei Minuten um den Kernel zu übersetzen. Das kann man gut erwarten.

Grüße
Alexander
Back to top
View user's profile Send private message
Display posts from previous:   
Reply to topic    Gentoo Forums Forum Index Deutsches Forum (German) All times are GMT
Page 1 of 1

 
Jump to:  
You cannot post new topics in this forum
You cannot reply to topics in this forum
You cannot edit your posts in this forum
You cannot delete your posts in this forum
You cannot vote in polls in this forum